import { ComponentLike, MetadataComponent } from '../common/types';
import { MetadataSet } from './types';
/**
 * A collection that contains no duplicate MetadataComponents. Components are hashed
 * by their FullName and metadata type id.
 */
export declare class ComponentSet<T extends MetadataComponent> implements MetadataSet, Iterable<T> {
    private map;
    constructor(components?: Iterable<T>);
    add(component: T): void;
    get(component: MetadataComponent): T | undefined;
    has(component: ComponentLike): boolean;
    values(): IterableIterator<T>;
    [Symbol.iterator](): Iterator<T>;
    get size(): number;
    private key;
}
