import { ComponentLike, MetadataComponent } from '../common';
import { RegistryAccess, TreeContainer } from '../metadata-registry';
import { ComponentSet } from './componentSet';
export interface PackageTypeMembers {
    name: string;
    members: string[];
}
export interface PackageManifestObject {
    Package: {
        types: PackageTypeMembers[];
        version: string;
    };
}
export interface WorkingSetOptions {
    registry?: RegistryAccess;
}
export interface FromSourceOptions extends WorkingSetOptions {
    tree?: TreeContainer;
}
export interface FromManifestOptions extends FromSourceOptions {
    resolve?: string;
    literalWildcard?: boolean;
}
export interface SourceComponentOptions {
    tree?: TreeContainer;
    filter?: MetadataComponent[] | ComponentSet<MetadataComponent>;
}
export interface MetadataSet {
    add(component: ComponentLike): void;
    has(component: ComponentLike): boolean;
    [Symbol.iterator](): Iterator<MetadataComponent>;
}
